Index: ChangeLog
===================================================================
--- ChangeLog	(revision a836200bd06580bd1af73b18e4e365e6ea92db2e)
+++ ChangeLog	(revision 15283bb262a596e38cf9c59b498670211458c33d)
@@ -1,5 +1,8 @@
 $Id$
 
-2.0.10-pre-1
+2.0.11-pre-1
+	Updated basic help
+	
+2.0.10
 	Allow 'hostname' in filters.
 	Fixed bug in reporting when no one is subbed to a class
Index: commands.c
===================================================================
--- commands.c	(revision 49d467c9419ca1be59dd7d5de3fd564d3089cf4a)
+++ commands.c	(revision 15283bb262a596e38cf9c59b498670211458c33d)
@@ -569,5 +569,5 @@
 
   OWLCMD_ARGS("show", owl_command_show, OWL_CTX_INTERACTIVE,
-	      "show information\n",
+	      "show information",
 	      "show colors\n"
 	      "show commands\n"
Index: help.c
===================================================================
--- help.c	(revision 55faab726a56fd9a344653603a56785cd24237b4)
+++ help.c	(revision 15283bb262a596e38cf9c59b498670211458c33d)
@@ -4,5 +4,6 @@
 static const char fileIdent[] = "$Id$";
 
-void owl_help() {
+void owl_help()
+{
   owl_fmtext fm;
   char *varname;
@@ -43,5 +44,5 @@
      "    u             Undelete a message marked for deletion\n"
      "    x             Expunge deleted messages\n"
-     "    X             Expunge deleted messages and switch view\n"
+     "    X             Expunge deleted messages and switch to home view\n"
      "    T             Mark all 'trash' messages for deletion\n"
      "    M-D           Mark all messages in current view for deletion\n"
@@ -49,18 +50,20 @@
      "\n"
      "    z             Start a zwrite command\n"
+     "    a             Start an aimwrite command\n"
      "    r             Reply to the current message\n"
      "    R             Reply to sender\n"
      "    C-r           Reply but allow editing of reply line\n"
      "\n"
-     "    M-n           View zephyrs to selected conversation\n"
-     "    M-N           View zephyrs to selected converstaion by instance\n"
+     "    M-n           View zephyrs in selected conversation\n"
+     "    M-N           View zephyrs in selected converstaion of instance\n"
      "    V             Change to back to home view ('all' by default)\n"
      "    v             Start a view command\n"
      "\n"
-     "    l             Print a list of users in .anyone that are logged in\n"
+     "    l             Print a zephyr/AIM buddy listing\n"
      "    A             Toggle zaway\n"
-     "    w             Open a URL in the message in netscape\n"
+     "    o             Toggle one-line display mode\n"
+     "    w             Open a URL in the current message\n"
      "    C-l           Refresh the screen\n"
-     "    C-z           Suspend\n"
+     "    C-z           Suspend Owl\n"
      "    h             Print this help message\n"
      "    : , M-x       Enter command mode\n"
@@ -81,13 +84,27 @@
      "\n"
      "    zwrite        Send a zephyr\n"
-     "    reply         Reply to the current zephyr\n"
+     "    aimlogin      Login to AIM\n"
+     "    aimwrite      Send an AIM message\n"
      "\n"
-     "    zlog          Send a login or logout notification\n"
+     "    addbuddy      Add a zephyr or AIM buddy\n"
+     "    zaway         Turn zaway on or off, or set the message\n"
+     "    zlocate       Locate a user\n"
      "    subscribe     Subscribe to a zephyr class or instance\n"
      "    unsubscribe   Unsubscribe to a zephyr class or instance\n"
+     "    blist         Print a list of zephyr and AIM buddies logged in\n"
+     "    search        Search for a text string\n"
+     "\n"
+     "    set           Set a variable (see list below)\n"
+     "    print         Print a variable's value (variables listed below)\n"
+     "    startup       Set a command to be run at every Owl startup\n"
+     "    unstartup     Remove a command to be run at every Owl startup\n"
+     "\n"
+     "    getsubs       Print a list of current subscriptions\n"
      "    unsuball      Unsubscribe from all zephyr classes\n"
-     "    getsubs       Print a list of current subscriptions\n"
-     "    zlocate       Locate a user\n"
-     "    zlist         Print a list of users in .anyone that are logged in\n"
+     "    load-subs     Load zephyr subscriptions from a file\n"
+     "    zpunt         Supress messages from a zephyr triplet\n"
+     "    zlog          Send a login or logout notification\n"
+     "    zlist         Print a list of zephyr buddies logged in\n"
+     "    alist         Print a list of AIM buddies logged in\n"
      "    info          Print detailed information about the current message\n"
      "    filter        Create a message filter\n"
@@ -96,10 +113,7 @@
      "    viewclass     View messages to a particular class\n"
      "    expunge       Expunge messages marked for deletion\n"
-     "    zaway         Turn zaway on or off, or set the message\n"
-     "    load-subs     Load zephyr subscriptions from a file\n"
-     "    search        Search for a text string\n"
-     "\n"
-     "    set           Set a variable (see list below)\n"
-     "    print         Print a variable's value (variables listed below)\n"
+     "    bindkey       Create a new key binding\n"
+     "    alias         Create a command alias\n"
+     "    dump\n"
      "\n"
      "    about         Print information about owl\n"
Index: logging.c
===================================================================
--- logging.c	(revision 269ed344ab73e113b7c213ac137a03221deb4317)
+++ logging.c	(revision 15283bb262a596e38cf9c59b498670211458c33d)
@@ -7,5 +7,6 @@
 static const char fileIdent[] = "$Id$";
 
-void owl_log_outgoing_zephyr(char *to, char *text) {
+void owl_log_outgoing_zephyr(char *to, char *text)
+{
   FILE *file;
   char filename[MAXPATHLEN], *logpath;
@@ -94,5 +95,6 @@
 }
 
-void owl_log_incoming(owl_message *m) {
+void owl_log_incoming(owl_message *m)
+{
   FILE *file, *allfile;
   char filename[MAXPATHLEN], allfilename[MAXPATHLEN], *logpath;
Index: owl.h
===================================================================
--- owl.h	(revision 49d467c9419ca1be59dd7d5de3fd564d3089cf4a)
+++ owl.h	(revision 15283bb262a596e38cf9c59b498670211458c33d)
@@ -19,6 +19,6 @@
 static const char owl_h_fileIdent[] = "$Id$";
 
-#define OWL_VERSION         2.0.10-pre-1
-#define OWL_VERSION_STRING "2.0.10-pre-1"
+#define OWL_VERSION         2.0.11-pre-1
+#define OWL_VERSION_STRING "2.0.11-pre-1"
 
 /* Feature that is being tested to redirect stderr through a pipe. 